//+------------------------------------------------------------------+
//|                                   Stochastic different pairs.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 20
#property indicator_level2 80
#property indicator_level3 50
#property indicator_buffers 3

extern int K = 100;
extern int D = 1;
extern int S = 1;
 
extern string  FirstSymbol = "";
extern string  SecondSymbol = "XXXXXX";
extern bool    AlertOn = true;
extern bool    EmailOn = true;
extern int     AlertAtorAbove = 80;
extern int     AlertAtorBelow = 50;
extern int     FontSize = 17;
extern color   FirstColor = DodgerBlue;
extern color   SecondColor = Red;
extern color   DiffColor = Yellow;
extern color   DeltaColor = White;
extern int     FirstX_Coordinate = 0;
extern int     FirstY_Coordinate = 15;
extern int     SecondX_Coordinate = 200;
extern int     SecondY_Coordinate = 15;
extern int     DiffX_Coordinate = 110;
extern int     DiffY_Coordinate = 15;
extern int     DeltaPip_X_Coordinate   = 925;
extern int     DeltaPip_Y_Coordinate   = 100; 
extern bool    InvertFirstSymbol = false;
extern bool    InvertSecondSymbol = false;
extern bool    CorrelationLabelOn = true;
extern bool    Show_DeltaPip = true;
extern int     CorrelationTimeFrame = 1440;
extern string  Note = "Zero CorrelationPeriods counts all bars"; 
extern int     CorrelationPeriods   = 50;


double buffer1[], buffer2[],buffer3[];
string m="";
int    win;
string Text1,Text2,Text3,T="NotValid";
datetime alertoncea=0, alertoncee=0,alertonceb=0, alertoncec=0,once=0;
bool     emailonce = true,alertonce = true; 
double a_above=1, e_above=1,DeltaPip1, DeltaPip2, DeltaPip3, DeltaPip4;
string s[31],first,second;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
      
            if( FirstSymbol=="audcad" )FirstSymbol="AUDCADm" ;
            if( FirstSymbol=="audchf" )FirstSymbol="AUDCHFm" ;
            if( FirstSymbol=="audjpy" )FirstSymbol="AUDJPYm" ;
            if( FirstSymbol=="audnzd" )FirstSymbol="AUDNZDm" ;
            if( FirstSymbol=="audusd" )FirstSymbol="AUDUSDm" ;
            if( FirstSymbol=="cadjpy" )FirstSymbol="CADJPYm" ;           
            if( FirstSymbol=="chfjpy" )FirstSymbol="CHFJPYm" ;
            if( FirstSymbol=="euraud" )FirstSymbol="EURAUDm" ;
            if( FirstSymbol=="eurcad" )FirstSymbol="EURCADm" ;
            if( FirstSymbol=="eurchf" )FirstSymbol="EURCHFm" ;
            if( FirstSymbol=="eurgbp" )FirstSymbol="EURGBPm" ;
            if( FirstSymbol=="eurjpy" )FirstSymbol="EURJPYm" ;
            if( FirstSymbol=="eurnzd" )FirstSymbol="EURNZDm" ;
            if( FirstSymbol=="eurusd" )FirstSymbol="EURUSDm" ;
            if( FirstSymbol=="gbpaud" )FirstSymbol="GBPAUDm" ;
            if( FirstSymbol=="gbpcad" )FirstSymbol="GBPCADm" ;
            if( FirstSymbol=="gbpchf" )FirstSymbol="GBPCHFm" ;
            if( FirstSymbol=="gbpjpy" )FirstSymbol="GBPJPYm" ;
            if( FirstSymbol=="gbpnzd" )FirstSymbol="GBPNZDm" ;
            if( FirstSymbol=="gbpusd" )FirstSymbol="GBPUSDm" ;
            if( FirstSymbol=="nzdchf" )FirstSymbol="NZDCHFm" ;
            if( FirstSymbol=="nzdjpy" )FirstSymbol="NZDJPYm" ;
            if( FirstSymbol=="nzdusd" )FirstSymbol="NZDUSDm" ;
            if( FirstSymbol=="usdcad" )FirstSymbol="USDCADm" ;
            if( FirstSymbol=="usdchf" )FirstSymbol="USDCHFm" ;
            if( FirstSymbol=="usdjpy" )FirstSymbol="USDJPYm" ;
            if( FirstSymbol=="eurdkk" )FirstSymbol="EURDKKm" ;
            if( FirstSymbol=="usdczk" )FirstSymbol="USDCZKm" ;
            if( FirstSymbol=="usddkk" )FirstSymbol="USDDKKm" ;
            if( FirstSymbol=="usdmxn" )FirstSymbol="USDMXNm" ;
            if( FirstSymbol=="usdpln" )FirstSymbol="USDPLNm" ;
            
            if( SecondSymbol=="audcad" )SecondSymbol="AUDCADm" ;
            if( SecondSymbol=="audchf" )SecondSymbol="AUDCHFm" ;
            if( SecondSymbol=="audjpy" )SecondSymbol="AUDJPYm" ;
            if( SecondSymbol=="audnzd" )SecondSymbol="AUDNZDm" ;
            if( SecondSymbol=="audusd" )SecondSymbol="AUDUSDm" ;
            if( SecondSymbol=="cadjpy" )SecondSymbol="CADJPYm" ;           
            if( SecondSymbol=="chfjpy" )SecondSymbol="CHFJPYm" ;
            if( SecondSymbol=="euraud" )SecondSymbol="EURAUDm" ;
            if( SecondSymbol=="eurcad" )SecondSymbol="EURCADm" ;
            if( SecondSymbol=="eurchf" )SecondSymbol="EURCHFm" ;
            if( SecondSymbol=="eurgbp" )SecondSymbol="EURGBPm" ;
            if( SecondSymbol=="eurjpy" )SecondSymbol="EURJPYm" ;
            if( SecondSymbol=="eurnzd" )SecondSymbol="EURNZDm" ;
            if( SecondSymbol=="eurusd" )SecondSymbol="EURUSDm" ;
            if( SecondSymbol=="gbpaud" )SecondSymbol="GBPAUDm" ;
            if( SecondSymbol=="gbpcad" )SecondSymbol="GBPCADm" ;
            if( SecondSymbol=="gbpchf" )SecondSymbol="GBPCHFm" ;
            if( SecondSymbol=="gbpjpy" )SecondSymbol="GBPJPmY" ;
            if( SecondSymbol=="gbpnzd" )SecondSymbol="GBPNZDm" ;
            if( SecondSymbol=="gbpusd" )SecondSymbol="GBPUSDm" ;
            if( SecondSymbol=="nzdchf" )SecondSymbol="NZDCHFm" ;
            if( SecondSymbol=="nzdjpy" )SecondSymbol="NZDJPYm" ;
            if( SecondSymbol=="nzdusd" )SecondSymbol="NZDUSDm" ;
            if( SecondSymbol=="usdcad" )SecondSymbol="USDCADm" ;
            if( SecondSymbol=="usdchf" )SecondSymbol="USDCHFm" ;
            if( SecondSymbol=="usdjpy" )SecondSymbol="USDJPYm" ;
            if( SecondSymbol=="eurdkk" )SecondSymbol="EURDKKm" ;
            if( SecondSymbol=="usdczk" )SecondSymbol="USDCZKm" ;
            if( SecondSymbol=="usddkk" )SecondSymbol="USDDKKm" ;
            if( SecondSymbol=="usdmxn" )SecondSymbol="USDMXNm" ;
            if( SecondSymbol=="usdpln" )SecondSymbol="USDPLNm" ;
            
            
      
      m = StringSubstr(Symbol(),6,StringLen(Symbol())-6);
      SecondSymbol = SecondSymbol+m;
      if (FirstSymbol == "" )
         FirstSymbol = Symbol();
      else
         FirstSymbol = FirstSymbol+m;
       
      //Table of Variables for Symbols
      s[0]="AUDCADm"+m;  s[1]="AUDCHFm"+m;  s[2]="AUDJPYm"+m;  s[3]="AUDNZDm"+m;  s[4]="AUDUSDm"+m;
      s[5]="CADJPYm"+m;  s[6]="CHFJPYm"+m;  s[7]="EURAUDm"+m;  s[8]="EURCADm"+m;  s[9]="EURCHFm"+m;
      s[10]="EURGBPm"+m; s[11]="EURJPYm"+m; s[12]="EURNZDm"+m; s[13]="EURUSDm"+m; s[14]="GBPAUDm"+m; 
      s[15]="GBPCADm"+m; s[16]="GBPCHFm"+m; s[17]="GBPJPYm"+m; s[18]="GBPNZDm"+m; s[19]="GBPUSDm"+m;
      s[20]="NZDCHFm"+m; s[21]="NZDJPYm"+m; s[22]="NZDUSDm"+m; s[23]="USDCADm"+m; s[24]="USDCHFm"+m;
      s[25]="USDJPYm"+m; s[26]="EURDKKm"+m; s[27]="USDCZKm"+m; s[28]="USDDKKm"+m; s[29]="USDMXNm"+m;
      s[30]="USDPLNm"+m;  
     
      for ( int nn=0;nn<31;nn++ )
         {
            if ( s[nn] == FirstSymbol )
               first = DoubleToStr(nn,0);
            if ( s[nn] == SecondSymbol )
               second = DoubleToStr(nn,0);   
         }
      
      //GlobalVariableSet("AA"+first+" "+second,0);
      //GlobalVariableSet("EA"+first+" "+second,0);
      a_above = GlobalVariableGet("AA"+first+" "+second);
      e_above = GlobalVariableGet("AA"+first+" "+second);
      
      
      
      string name,char4;
      
         
            int obj = ObjectsTotal();
            for ( int n=obj;n > 0 ;n--)
               {
                  name = ObjectName(n);
                  char4 = StringSubstr(name,0,4);
                  if ( char4 == "Diff" )
                    ObjectDelete(name);   
               }
       if ( CorrelationTimeFrame == 1 ) T = "M1";
       if ( CorrelationTimeFrame == 5 ) T = "M5";
       if ( CorrelationTimeFrame == 15 ) T = "M15";
       if ( CorrelationTimeFrame == 30 ) T = "M30";
       if ( CorrelationTimeFrame == 60 ) T = "H1";
       if ( CorrelationTimeFrame == 240 ) T = "H4";
       if ( CorrelationTimeFrame == 1440 ) T = "D1";
       if ( CorrelationTimeFrame == 10080 ) T = "W1";
       if ( CorrelationTimeFrame == 43200 ) T = "MN";        
               
       IndicatorShortName("Stochastic 1.7("+K+","+D+","+S+") "+FirstSymbol+"|"+SecondSymbol);
       win = WindowFind("Stochastic 1.7("+K+","+D+","+S+") "+FirstSymbol+"|"+SecondSymbol);        
       
                      
//---- indicators
      SetIndexBuffer(0,buffer1);
      SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,NULL,FirstColor);
      SetIndexLabel(0,FirstSymbol);

      SetIndexBuffer(1,buffer2);
      SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,NULL,SecondColor);
      SetIndexLabel(1,SecondSymbol);    

      SetIndexBuffer(2,buffer3);
      SetIndexStyle(2,DRAW_LINE,STYLE_DOT,NULL,DiffColor);
      SetIndexLabel(2,"Difference");    
      SetIndexEmptyValue(2,0.0);

IndicatorDigits(2);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
   string name,char4;
      
      
            int obj = ObjectsTotal();
            for ( int n=obj;n > 0 ;n--)
               {
                  name = ObjectName(n);
                  char4 = StringSubstr(name,0,4);
                  if ( char4 == "Diff" )
                    ObjectDelete(name);   
               }
              
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   string corcomment;
   int    i,counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
      int limit=Bars-counted_bars;
      
      for(i=limit; i>=0; i--)
         {
            if ( InvertFirstSymbol)
               buffer1[i] = 100-iStochastic(FirstSymbol,0,K,D,S,0,0,0,i);
            else
               buffer1[i] = iStochastic(FirstSymbol,0,K,D,S,0,0,0,i);   
            if ( InvertSecondSymbol )
               buffer2[i] = 100-iStochastic(SecondSymbol,0,K,D,S,0,0,0,i);
            else
               buffer2[i] = iStochastic(SecondSymbol,0,K,D,S,0,0,0,i);
               
            buffer3[i] = MathAbs(buffer1[i]-buffer2[i]);
            if((buffer3[i+1]< 20) && (buffer3[i] > 20))
                {DeltaPip1 = MathAbs(iClose(FirstSymbol,0,i+1)-iClose(FirstSymbol,PERIOD_M1,0));
                 DeltaPip2 = MathAbs(iClose(SecondSymbol,0,i+1)-iClose(SecondSymbol,PERIOD_M1,0));}
                                                
                                              
                                                
         } 
         
      if ( buffer3[1] < AlertAtorAbove )
         {
            emailonce = true;
            alertonce = true;
         } 
           
      if ( AlertOn && alertoncea != Time[0] )
         {
            if ( buffer3[1] >= AlertAtorAbove && alertonce)
               {
                  Alert(FirstSymbol+"% - "+SecondSymbol+"% is > "+AlertAtorAbove+"  "+TimeToStr(Time[1],TIME_DATE|TIME_MINUTES));
                  alertoncea = Time[0];
                  alertonce = false;
                  GlobalVariableSet("AA"+first+" "+second,1);
               }
               
         }
      
             
      if ( EmailOn && alertoncee != Time[0] )
         {
            if ( buffer3[1] >= AlertAtorAbove && emailonce )
               {
                  SendMail("Stochastic Pair",FirstSymbol+"% - "+SecondSymbol+"% is > "+AlertAtorAbove+"  "+TimeToStr(Time[1],TIME_DATE|TIME_MINUTES));
                  alertoncee = Time[0];
                  emailonce = false;
                  GlobalVariableSet("EA"+first+" "+second,1);
               }
               
         }

      a_above = GlobalVariableGet("AA"+first+" "+second);
      if ( AlertOn && alertonceb != Time[0] && a_above == 1 )
         {
            if ( buffer3[1] <= AlertAtorBelow )
               {
                  Alert(FirstSymbol+"% - "+SecondSymbol+"% is < "+AlertAtorBelow+"  "+TimeToStr(Time[1],TIME_DATE|TIME_MINUTES));
                  alertonceb = Time[0];
                  GlobalVariableSet("AA"+first+" "+second,0);
               }
               
         }
      
      e_above = GlobalVariableGet("EA"+first+" "+second);       
      if ( EmailOn && alertoncec != Time[0] && e_above == 1 )
         {
            if ( buffer3[1] <= AlertAtorAbove )
               {
                  SendMail("Stochastic Pair",FirstSymbol+"% - "+SecondSymbol+"% is < "+AlertAtorBelow+"  "+TimeToStr(Time[1],TIME_DATE|TIME_MINUTES));
                  alertoncec = Time[0];
                  GlobalVariableSet("EA"+first+" "+second,0);
               }
               
         }             
    if ( CorrelationLabelOn )
      {
      if ( once != iTime(Symbol(),CorrelationTimeFrame,0) )
         {               
            corcomment = correlation2pair();
            once = iTime(Symbol(),CorrelationTimeFrame,0);
            ObjectDelete("Diff4"+FirstSymbol+SecondSymbol);  
            ObjectCreate("Diff4"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
            ObjectSet("Diff4"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, FirstX_Coordinate);
            ObjectSet("Diff4"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, FirstY_Coordinate+20); 
            ObjectSetText("Diff4"+FirstSymbol+SecondSymbol,corcomment, FontSize,"Arial",DiffColor);

         }
      }    
       
      
      
  
      
     if (Show_DeltaPip)
     {
     DeltaPip1=DeltaPip1*MathPow(10,MarketInfo(FirstSymbol,MODE_DIGITS));
     DeltaPip2=DeltaPip2*MathPow(10,MarketInfo(SecondSymbol,MODE_DIGITS));
     
      string DeltaString =            FirstSymbol + ": " + DoubleToStr(DeltaPip1,0);
      string DeltaString1 =           SecondSymbol+ ": " + DoubleToStr(DeltaPip2,0);
      string DeltaString2 =           "Combined"  + ": " + DoubleToStr(DeltaPip1+DeltaPip2,0);
      
     
            ObjectDelete("DiffDeltaPip"+FirstSymbol+SecondSymbol);  
            ObjectCreate("DiffDeltaPip"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
            ObjectSet("DiffDeltaPip"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, DeltaPip_X_Coordinate);
            ObjectSet("DiffDeltaPip"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, DeltaPip_Y_Coordinate); 
            ObjectSetText("DiffDeltaPip"+FirstSymbol+SecondSymbol,DeltaString, FontSize-6,"Arial",DeltaColor);
     
            
            ObjectDelete("DiffDeltaPip1"+FirstSymbol+SecondSymbol);  
            ObjectCreate("DiffDeltaPip1"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
            ObjectSet("DiffDeltaPip1"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, DeltaPip_X_Coordinate);
            ObjectSet("DiffDeltaPip1"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, DeltaPip_Y_Coordinate+15); 
            ObjectSetText("DiffDeltaPip1"+FirstSymbol+SecondSymbol,DeltaString1, FontSize-6,"Arial",DeltaColor);
            
            
            ObjectDelete("DiffDeltaPip2"+FirstSymbol+SecondSymbol);  
            ObjectCreate("DiffDeltaPip2"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
            ObjectSet("DiffDeltaPip2"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, DeltaPip_X_Coordinate);
            ObjectSet("DiffDeltaPip2"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, DeltaPip_Y_Coordinate+30  ); 
            ObjectSetText("DiffDeltaPip2"+FirstSymbol+SecondSymbol,DeltaString2, FontSize-6,"Arial",DeltaColor);


      }
      
      Text1 = StringSubstr(FirstSymbol,0,6);
      Text2 = StringSubstr(SecondSymbol,0,6);

      ObjectDelete("Diff1"+FirstSymbol+SecondSymbol);
      ObjectDelete("Diff2"+FirstSymbol+SecondSymbol);

      ObjectCreate("Diff1"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
      ObjectSet("Diff1"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, FirstX_Coordinate);
      ObjectSet("Diff1"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, FirstY_Coordinate); 
      ObjectSetText("Diff1"+FirstSymbol+SecondSymbol,Text1, FontSize,"Arial",FirstColor);
      
      ObjectCreate("Diff2"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
      ObjectSet("Diff2"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, SecondX_Coordinate);
      ObjectSet("Diff2"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, SecondY_Coordinate); 
      ObjectSetText("Diff2"+FirstSymbol+SecondSymbol,Text2, FontSize,"Arial",SecondColor);      
      
      Text3 = "Diff "+DoubleToStr(buffer3[0], 0)+" Coincides with ";
                
      ObjectDelete("Diff3"+FirstSymbol+SecondSymbol);      
      ObjectCreate("Diff3"+FirstSymbol+SecondSymbol,OBJ_LABEL,win,0,0);
      ObjectSet("Diff3"+FirstSymbol+SecondSymbol,OBJPROP_XDISTANCE, DiffX_Coordinate);
      ObjectSet("Diff3"+FirstSymbol+SecondSymbol,OBJPROP_YDISTANCE, DiffY_Coordinate); 
      ObjectSetText("Diff3"+FirstSymbol+SecondSymbol,Text3, FontSize,"Arial",DiffColor);
      
 
      
      
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+

string   correlation2pair()
{
	string   Symbol1     = FirstSymbol, Symbol2 = SecondSymbol, cor; 
	int      TimeFrame   = CorrelationTimeFrame;
	datetime closeTime1	= iTime(Symbol1,TimeFrame,0),
				closeTime2	= iTime(Symbol2,TimeFrame,0),
				closeTime	= MathMin(closeTime1,closeTime2);
	int		shift1		= iBarShift(Symbol1,TimeFrame,closeTime),
				shift2		= iBarShift(Symbol2,TimeFrame,closeTime);
	double	close1[],
				close2[];

	ArrayCopySeries(close1,MODE_CLOSE,Symbol1,TimeFrame);
	ArrayCopySeries(close2,MODE_CLOSE,Symbol2,TimeFrame);

	int bars = MathMin(ArraySize(close1)-shift1,ArraySize(close2)-shift2);
	if ( CorrelationPeriods > 0 )
	     bars = CorrelationPeriods;
   double C = Correlation(close1,close2,shift1,shift2,bars);
   
   
	cor = "Correlation "+T+" @ "+bars+" Periods = "+DoubleToStr(100*C,1)+"%";
	return(cor);
}

//+------------------------------------------------------------------+
//| Correlation Coefficient R														|
//+------------------------------------------------------------------+
double Correlation(double x[], double y[], int x_shift = 0, int y_shift = 0, int count = -1)
{
	Print(x_shift,"  ",y_shift,"  ",count);
	int n = MathMin(ArraySize(x)-x_shift,ArraySize(y)-y_shift);
	if(n>count && count>0)
		n=count;
	if(n<2)
		return(-2);

	double	sum_sq_x,
				sum_sq_y,
				sum_coproduct,
				mean_x = x[x_shift],
				mean_y = y[y_shift];

	for(int i = 0; i < n; i++)
	{
		double	sweep = i / (i+1.0),
					delta_x = x[i+x_shift] - mean_x,
					delta_y = y[i+y_shift] - mean_y;

		sum_sq_x += delta_x*delta_x * sweep;
		sum_sq_y += delta_y*delta_y * sweep;
    	sum_coproduct += delta_x*delta_y * sweep;
    	mean_x += delta_x / (i+1.0);
    	mean_y += delta_y / (i+1.0);
	}

	double	pop_sd_x = MathSqrt(sum_sq_x/n),
				pop_sd_y = MathSqrt(sum_sq_y/n),
				cov_x_y = sum_coproduct / n;

	if(pop_sd_x*pop_sd_y != 0.0)
		return(cov_x_y / (pop_sd_x*pop_sd_y));

	return(-3);
}